//=============================================================================
// Change_LimitBreak.js
//   Last update: 2024/09/15
//=============================================================================
// 更新っぽいもの
// 
// 2024/08/01 [v0.1.0]
// 初版
// 
// 2024/08/18 [v0.1.1]
// TP上限とセーブファイル上限を追加
// 
// 2024/09/15 [v0.1.1]
// プラグインのヘルプを更新

/*:
 * @plugindesc
 * [v0.1.1] Change!! Limmit Break.
 * 
 * @author Diamond
 *
 * @param Max Level
 * @text ????
 * @default 100
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Battler Max HP
 * @text ????
 * @default 500000
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Battler Max MP
 * @text ????
 * @default 250000
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Battler Max Sts
 * @text ????
 * @default 99999
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Max Gold
 * @text ????
 * @default 999999999
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Item Max Hold
 * @text ????
 * @default 125
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Max Battle Members
 * @text ????
 * @default 4
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Battler Max TP
 * @text ????
 * @default 120
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @param Max Save
 * @text ????
 * @default 25
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 *
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 */

/*:ja
 * @plugindesc
 * [v0.1.1] 真（チェンジ！！）限界突破
 * 
 * @author 貪藻矢射妥←
 *
 * @param Max Level
 * @text 最大レベル
 * @default 100
 * @desc レベル上限を指定します。
 *
 * @param Battler Max HP
 * @text 最大HP
 * @default 500000
 * @desc バトラーのMaxHPを指定します。
 *
 * @param Battler Max MP
 * @text 最大MP
 * @default 250000
 * @desc バトラーのMaxMPを指定します。
 *
 * @param Battler Max Sts
 * @text HP/MP以外の最大値
 * @default 99999
 * @desc バトラーのMaxステータス値を指定します。
 *
 * @param Max Gold
 * @text ゴールド最大値
 * @default 999999999
 * @desc 所持金の上限を指定します。
 *
 * @param Item Max Hold
 * @text アイテム所持数最大値
 * @default 125
 * @desc アイテム所持数の上限を指定します。
 *
 * @param Max Battle Members
 * @text パーティーメンバー最大値
 * @default 4
 * @desc パーティーメンバー上限を指定します。
 *
 * @param Battler Max TP
 * @text 最大TP
 * @default 120
 * @desc バトラーのMaxTPを指定します。
 *
 * @param Max Save
 * @text セーブファイル最大値
 * @default 25
 * @desc セーブファイル上限を指定します。
 *
 * @help
 * ゲーム内の各種上限値を設定し直します。
 *
 * ※注意事項※
 * Lv上限を100以上に変更した後、
 * RPGツクールXP/VX/VXA RGSS ツクールMV/MZパラメータジェネレーター
 * で作成したパラメータリストを
 * data/Classes.json の 
 * "params":[[hogehoge]] の [[hogehoge]]の部分と差し替えてください。
 * あるいはRubyツールのパラメータジェネレーターでClasses.jsonを更新してください。
 * そうしないとLv100以降バグります。
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 */

var OuterFlgs = OuterFlgs || {};

(function() {

OuterFlgs.imported = OuterFlgs.imported || {};
OuterFlgs.imported['LimitBreak'] = true;

var pluginParams = PluginManager.parameters('Change_LimitBreak');
var changeLimitBreakMaxLevel         = Number(pluginParams['Max Level'] || 100);
var changeLimitBreakBattlerMhp       = Number(pluginParams['Battler Max HP'] || 500000);
var changeLimitBreakBattlerMmp       = Number(pluginParams['Battler Max MP'] || 250000);
var changeLimitBreakBattlerMsts      = Number(pluginParams['Battler Max Sts'] || 99999);
var changeLimitBreakMaxGold          = Number(pluginParams['Max Gold'] || 999999999);
var changeLimitBreakItemMaxHold      = Number(pluginParams['Item Max Hold'] || 125);
var changeLimitBreakMaxBattleMembers = Number(pluginParams['Max Battle Members'] || 4);
var changeLimitBreakBattlerMtp       = Number(pluginParams['Battler Max TP'] || 120);
var changeLimitBreakMaxSave          = Number(pluginParams['Max Save'] || 25);

//-----------------------------------------------------------------------------
// Game_Actor

Game_Actor.prototype.maxLevel = function() {
    return changeLimitBreakMaxLevel;
};

Game_Actor.prototype.paramMax = function(paramId) {
    if (paramId === 0) {
        return changeLimitBreakBattlerMhp;    // MHP
    }
    return Game_Battler.prototype.paramMax.call(this, paramId);
};

//-----------------------------------------------------------------------------
// Game_BattlerBase

Game_BattlerBase.prototype.paramMax = function(paramId) {
    switch (paramId){
    case 0:  // MHP
        return changeLimitBreakBattlerMhp;
        break;
    case 1:  // MMP
        return changeLimitBreakBattlerMmp;
        break;
    default: // その他ステータス
        return changeLimitBreakBattlerMsts;
        breal;
    }
};

Game_BattlerBase.prototype.maxTp = function() {
    return changeLimitBreakBattlerMtp;
};

//-----------------------------------------------------------------------------
// Game_Party

Game_Party.prototype.maxGold = function() {
    return changeLimitBreakMaxGold;
};


Game_Party.prototype.maxItems = function(item) {
    return changeLimitBreakItemMaxHold;
};


Game_Party.prototype.maxBattleMembers = function() {
    return changeLimitBreakMaxBattleMembers;
};

//-----------------------------------------------------------------------------
// DataManager

DataManager.maxSavefiles = function() {
    return changeLimitBreakMaxSave;
};

})();
